﻿#region CVS Version Header
/*
 * $Id: Singleton.cs,v 1.8 2007/04/16 19:31:57 Bill SerGio Exp $
 * Last modified by $Author: Bill SerGio $
 * Last modified at $Date: 2007/04/16 19:31:57 $
 * $Revision: 1.8 $
 */
#endregion

using System;
using System.Collections;
using System.Collections.Specialized;
using System.Collections.Generic;
using System.Configuration;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Security.Cryptography;
using System.Text.RegularExpressions;
using System.Text;
using System.Runtime.CompilerServices; // for MethodImplAttribute


namespace DomainGenie
{
    /// <summary>
    /// Summary description for CWSingleton
    /// Dim oSingleton As singleton = singleton.GetCurrentSingleton()
    /// singleton oSingleton = singleton.GetCurrentSingleton
    /// </summary>
    [Serializable]
    public sealed class singleton
    {

        //Variables to store data 
        string appDir = "";
        string userData = "demo";
        //string[] roles = UserData.Split(',');
        string[] roles = new string[] { };

        bool bAuthorized = false;
        bool bIsSysop = false;
        bool bIsAdmin = false;
        string username = string.Empty;
        string password = string.Empty;
        string clientCode = "";
        string lastName = "";
        string firstName = "";
        bool bSortAscending = false;

        // Crystal Report Variables
        bool bLoadReport = false;
        bool bParamLoaded = false;
        string reportFile = "";
        string reportFileName = "";
        //CrystalDecisions.CrystalReports.Engine.ReportDocument crDoc = null;

        /// <summary>
        /// Directory where application is stored
        /// </summary>
        public string AppDir
        {
            get { return appDir; }
            set { appDir = value; }
        }

        public string UserData
        {
            get { return userData; }
            set { userData = value; }
        }

        public string[] Roles
        {
            get 
            {
                roles = userData.Split(',');
                return roles; 
            }
        }

        //string userData = "demo";
        ////string[] roles = UserData.Split(',');
        //string[] roles = new string[] { };

        /// <summary>
        /// LoadReport
        /// </summary>
        public bool LoadReport
        {
            get { return bLoadReport; }
            set { bLoadReport = value; }
        }

        /// <summary>
        /// ParamLoaded
        /// </summary>
        public bool ParamLoaded
        {
            get { return bParamLoaded; }
            set { bParamLoaded = value; }
        }

        /// <summary>
        /// Name of the Crystal Report File without the .rpt extension
        /// </summary>
        public string ReportFile
        {
            get { return reportFile; }
            set { reportFile = value; }
        }

        /// <summary>
        /// Full pathway of the .rpt Report File with .rpt extension
        /// </summary>
        public string ReportFileName
        {
            get { return reportFileName; }
            set { reportFileName = value; }
        }


        public bool Authorized
        {
            get { return bAuthorized; }
            set { bAuthorized = value; }
        }

        public bool IsSysop
        {
            get { return bIsSysop; }
            set { bIsSysop = value; }
        }

        public bool IsAdmin
        {
            get { return bIsAdmin; }
            set { bIsAdmin = value; }
        }

        public string Username
        {
            get { return username; }
            set { username = value; }
        }

        public string Password
        {
            get { return password; }
            set { password = value; }
        }

        public string ClientCode
        {
            get { return clientCode; }
            set { clientCode = value; }
        }

        public string LastName
        {
            get { return lastName; }
            set { lastName = value; }
        }

        public string FirstName
        {
            get { return firstName; }
            set { firstName = value; }
        }

        public bool SortAscending
        {
            get { return bSortAscending; }
            set { bSortAscending = value; }
        }

        ///////////////////////////////////////////////////////////////
        //int stationid = 0;
        //public int iStationid
        //{
        //    get { return stationid; }
        //    set { stationid = value; }
        //}

        string stationid = string.Empty;
        public string sStationID
        {
            get { return stationid; }
            set { stationid = value; }
        }

        string station = string.Empty;
        public string sStation
        {
            get { return station; }
            set { station = value; }
        }

        string dash = string.Empty;
        public string sDash
        {
            get { return dash; }
            set { dash = value; }
        }

        int fcc_cableid = 0;
        public int iFcc_cableid
        {
            get { return fcc_cableid; }
            set { fcc_cableid = value; }
        }


        string fcc_fac_callsign = string.Empty;
        public string sFcc_fac_callsign
        {
            get { return fcc_fac_callsign; }
            set { fcc_fac_callsign = value; }
        }

        string fcc_fac_id = "0";
        public string sFcc_fac_id
        {
            get { return fcc_fac_id; }
            set { fcc_fac_id = value; }
        }

        string fcc_fac_service = string.Empty;
        public string sFcc_fac_service
        {
            get { return fcc_fac_service; }
            set { fcc_fac_service = value; }
        }

        string media = string.Empty;
        public string sMedia
        {
            get { return media; }
            set { media = value; }
        }

        string aff1 = string.Empty;
        public string sAff1
        {
            get { return aff1; }
            set { aff1 = value; }
        }

        string aff2 = string.Empty;
        public string sAff2
        {
            get { return aff2; }
            set { aff2 = value; }
        }

        string fcc_fac_channel = "0";
        public string sFcc_fac_channel
        {
            get { return fcc_fac_channel; }
            set { fcc_fac_channel = value; }
        }

        string fcc_fac_frequency = "0";
        public string sFcc_fac_frequency
        {
            get { return fcc_fac_frequency; }
            set { fcc_fac_frequency = value; }
        }

        string fcc_fac_type = string.Empty;
        public string sFcc_fac_type
        {
            get { return fcc_fac_type; }
            set { fcc_fac_type = value; }
        }

        string timezone = string.Empty;
        public string sTimezone
        {
            get { return timezone; }
            set { timezone = value; }
        }

        string rstations = string.Empty;
        public string sRstations
        {
            get { return rstations; }
            set { rstations = value; }
        }

        string test = string.Empty;
        public string sTest
        {
            get { return test; }
            set { test = value; }
        }

        string nationalstation = string.Empty;
        public string sNationalstation
        {
            get { return nationalstation; }
            set { nationalstation = value; }
        }

        string repcode = string.Empty;
        public string sRepcode
        {
            get { return repcode; }
            set { repcode = value; }
        }

        string tapeformat = string.Empty;
        public string sTapeformat
        {
            get { return tapeformat; }
            set { tapeformat = value; }
        }

        string stationformat = string.Empty;
        public string sStationformat
        {
            get { return stationformat; }
            set { stationformat = value; }
        }


        //string fcc_comm_city = string.Empty;
        //string fcc_comm_state = string.Empty;
        //string fcc_fac_address1 = string.Empty;
        //string fcc_fac_address2 = string.Empty;
        //string fcc_fac_pobox = string.Empty;
        //string fcc_fac_city = string.Empty;
        //string fcc_fac_state = string.Empty;
        //string fcc_fac_country = string.Empty;
        //string fcc_fac_zip1 = string.Empty;
        //string fcc_fac_zip2 = string.Empty;
        //string fcc_station_type = string.Empty;
        //int fcc_assoc_facility_id = 0;
        ////fcc_digital_status
        ////fcc_sat_tv
        //timezone
        //tapeformat
        //nationalstation
        //repcode
        //rstations
        //stationformat
        //test
        //agencydiscount
        //prepay
        //netpay
        //cancel
        //beginbal
        //credit_info
        //credit_spot
        //payee
        //adirank
        //adimkt
        //company
        //address1
        //address2
        //city
        //state
        //zip
        //country
        //tel1
        //tel2
        //tel3
        //tel4
        //tel5
        //tel6
        //email
        //notes
        //udf1
        //udf2
        //udf3
        //sales
        //tag

        string air_total = string.Empty;
        public string stat_air_total
        {
            get { return air_total; }
            set { air_total = value; }
        }
  
        string air_rank = string.Empty;
        public string stat_air_rank
        {
            get { return air_rank; }
            set { air_rank = value; }
        }

        string air_ranked = string.Empty;
        public string stat_air_ranked
        {
            get { return air_ranked; }
            set { air_ranked = value; }
        }

        string mg_total = string.Empty;
        public string stat_mg_total
        {
            get { return mg_total; }
            set { mg_total = value; }
        }

        string mg_rank = string.Empty;
        public string stat_mg_rank
        {
            get { return mg_rank; }
            set { mg_rank = value; }
        }

        string mg_ranked = string.Empty;
        public string stat_mg_ranked
        {
            get { return mg_ranked; }
            set { mg_ranked = value; }
        }

        string pi_total = string.Empty;
        public string stat_pi_total
        {
            get { return pi_total; }
            set { pi_total = value; }
        }

        string pi_rank = string.Empty;
        public string stat_pi_rank
        {
            get { return pi_rank; }
            set { pi_rank = value; }
        }

        string pi_ranked = string.Empty;
        public string stat_pi_ranked
        {
            get { return pi_ranked; }
            set { pi_ranked = value; }
        }

        string gpi_total = string.Empty;
        public string stat_gpi_total
        {
            get { return gpi_total; }
            set { gpi_total = value; }
        }

        string gpi_rank = string.Empty;
        public string stat_gpi_rank
        {
            get { return gpi_rank; }
            set { gpi_rank = value; }
        }

        string gpi_ranked = string.Empty;
        public string stat_gpi_ranked
        {
            get { return gpi_ranked; }
            set { gpi_ranked = value; }
        }

        string mgross_total = string.Empty;
        public string stat_mgross_total
        {
            get { return mgross_total; }
            set { mgross_total = value; }
        }

        string mgross_rank = string.Empty;
        public string stat_mgross_rank
        {
            get { return mgross_rank; }
            set { mgross_rank = value; }
        }

        string mgross_ranked = string.Empty;
        public string stat_mgross_ranked
        {
            get { return mgross_ranked; }
            set { mgross_ranked = value; }
        }

        string sgross_total = string.Empty;
        public string stat_sgross_total
        {
            get { return sgross_total; }
            set { sgross_total = value; }
        }

        string sgross_rank = string.Empty;
        public string stat_sgross_rank
        {
            get { return sgross_rank; }
            set { sgross_rank = value; }
        }

        string sgross_ranked = string.Empty;
        public string stat_sgross_ranked
        {
            get { return sgross_ranked; }
            set { sgross_ranked = value; }
        }

        //fcc
        //bought

        static readonly singleton oSingleton = new singleton();

        // Explicit static constructor to tell C# compiler
        // not to mark type as beforefieldinit
        static singleton()
        {
        }

        singleton()
        {
        }

        public static singleton GetCurrentSingleton
        {
            get
            {
                return oSingleton;
            }
        }
    }


}
