﻿

//#undef USEAUTOUPDATE
#define USEAUTOUPDATE

#region framework namespaces
using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Net.Sockets;
using System.Text.RegularExpressions;
using System.IO;
using System.Text;
using System.Xml;
using System.Configuration;

using Ini;
using NameGenerator;
using WhoisLib;

using System.Globalization;
using System.Reflection;
using System.Diagnostics;
using System.Security.Permissions;
#endregion

#region third party namespaces
//using AxSHDocVw;
//using SHDocVw;		// related interfaces

using MdiTabControl;
#endregion

#region project namespaces
using ExtendedWebBrowser2;
//using BlackBox;
#endregion

namespace DomainGenie
{

    public partial class WinGUIMain : Form
    {

        public enum TextSizeWB
        {
            Smallest = 0,
            Smaller = 1,
            Medium = 2,
            Larger = 3,
            Largest = 4
        }

        //private System.Windows.Forms.MenuStrip tsMenus;
 
        public delegate void NavigateToURLDelegate(string url, string tab, bool createNewTab, bool setFocus);
        public event EventHandler OnMinimize;
        private const int BrowserProgressBarWidth = 120;
        private Rectangle _formRestoreBounds = Rectangle.Empty;
        private bool _forceShutdown = false;
        private FormWindowState initialStartupState = FormWindowState.Normal;
        private System.Windows.Forms.ContextMenu _notifyContextMenu = null;

        //Images for statusbar, ....
        private Image m_imgLock = null;
        private Image m_imgUnLock = null;
        private Image m_imgAniProgress = null;

        public WinGUIMain(DomainGenieApplication theGuiOwner, FormWindowState initialFormState)
        {
            GuiOwner = theGuiOwner;
            this.initialStartupState = initialFormState;

            InitializeComponent();
            Init();

        }

        private static ExtendedWebBrowser _CurrentBrowser;
        //public static ExtendedWebBrowser CurrentBrowser
        //{
        //    get
        //    {
        //        return _CurrentBrowser;
        //    }
        //    set
        //    {
        //        _CurrentBrowser = value;
        //    }
        //}

        protected void Init()
        {
            //this.OnMinimize += new EventHandler(this.OnFormMinimize);

            //Win32.RECT rw = new Win32.RECT();
            //uint swpStyle = (uint)Win32.ShowWindowStyles.SW_HIDE | (uint)Win32.ShowWindowStyles.SW_SHOWNOACTIVATE;
            //Win32.SetWindowPos(this.Handle, this.Handle, -5000, 0, 0, 0, swpStyle);

            SetStyle(ControlStyles.DoubleBuffer, true);
            SetStyle(ControlStyles.AllPaintingInWmPaint, true);

            SetupImages();
            //InitResources();
            //InitShortcutManager();
            //InitMenuBar();
            //InitToolBars();
            //InitStatusBar();
            //InitDockHosts();
            //InitDocumentManager();
            //InitContextMenus();
            //InitTrayIcon();
            //InitWidgets();

            InitTabControls();

            LoadDefaultTabs();

            //swpStyle = (uint)Win32.ShowWindowStyles.SW_MAXIMIZE | (uint)Win32.ShowWindowStyles.SW_SHOW;
            //Win32.SetWindowPos(this.Handle, this.Handle, 0, 0, 0, 0, swpStyle);

        }

        private void ResizeMoveHiddenWindows()
        {
            //Win32.RECT rw = new Win32.RECT();
            //uint swpStyle = (uint)Win32.ShowWindowStyles.SW_HIDE;
            //Win32.SetWindowPos(this.Handle, this.Handle, -5000, 0, 0, 0, swpStyle);

        }



        protected void InitTabControls()
        {
            this.splitContainer1.Panel1.SuspendLayout();
            this.splitContainer1.Panel2.SuspendLayout();
            this.splitContainer1.SuspendLayout();
            this.SuspendLayout();
            // 
            // splitContainer1.Panel1
            // 
            this.splitContainer1.Panel1.Controls.Add(this.tabControl1);
            // 
            // splitContainer1.Panel2
            // 
            this.tabControl1.Dock = DockStyle.Fill;
            this.splitContainer1.Dock = DockStyle.Fill;



            //fs.Browser = DomainGenieApplication.CurrentBrowser;

            this.splitContainer1.Panel1.ResumeLayout(false);
            this.splitContainer1.Panel2.ResumeLayout(false);
            this.splitContainer1.ResumeLayout(false);
            this.ResumeLayout(false);
            this.PerformLayout();

        }


        public void StatusStripDelegateHandler(object sender, EventArgs e)
        {
            //tsStatus.Text = e.ToString();
        }


        /// <summary>
        /// Loads all images from a image strip into a
        /// static imagelist which in turn can 
        /// be used bey any form or control 
        /// capable of using images
        /// </summary>
        private void SetupImages()
        {

            try
            {
                Image img = global::DomainGenie.Properties.Resources.ietoolbar;
                DomainGenieApplication.m_imgListMain.TransparentColor = Color.FromArgb(192, 192, 192);
                DomainGenieApplication.m_imgListMain.Images.AddStrip(img);
            }
            catch (Exception ee)
            {
                //WinGUIMain.AllForms.m_frmLog.AppendToLog("\r\nError=" + ee.ToString());
            }
        }


        private static DomainGenieApplication owner = null;
        public DomainGenieApplication GuiOwner
        {
            get { return owner; }
            set { owner = value; }
        }

        public FormWindowState InitialStartupState
        {
            get { return initialStartupState; }
        }


        private string _urlText = String.Empty;	// don't know why navigateComboBox.ComboBox.Text returns an empty string after dragging a url to it, so we use this as a workaround

        protected void InitResources()
        {

        }


        public WinGUIMain()
        {
            InitializeComponent();

        }


        public void Close(bool forceShutdown)
        {
            _forceShutdown = forceShutdown;
            base.Close();
        }


        private void OnLoad(object sender, System.EventArgs eva)
        {
            //DomainGenieApplication.CurrentBrowser = this.cEXWB1;

            Random randGen = new Random();

            ////Start watching favorites folder
            //fswFavorites.Path = Environment.GetFolderPath(Environment.SpecialFolder.Favorites);

            ////Load favorites
            //LoadFavoriteMenuItems();

            WhoisForm aa = (WhoisForm)tabControl1.TabPages[0].Form;
            aa.Navigate +=new NavigateHandler(aa_Navigate);

            multiTabBrowser1.WebAction += new WebActionHandler(multiTabBrowser1_WebAction);

        }

        void multiTabBrowser1_WebAction(object sender, WebActionEventArgs e)
        {
            if (e.sAction == "minmax")
            {
                splitContainer1.Panel1Collapsed = !splitContainer1.Panel1Collapsed;
                splitContainer1.SplitterDistance = splitContainer1.Height/2;
                if(splitContainer1.Panel1Collapsed)
                    multiTabBrowser1.ChangeIcon(1);
                else
                    multiTabBrowser1.ChangeIcon(0);
            }


        }

        void aa_Navigate(object sender, NavigateEventArgs e)
        {
            if (e.bString)
                NavToString(e.url);
            else
                NavToUrl(e.url);
        }


        public void NavToUrl(string sUrl)
        {
            if (!CheckWBPointer())
                return;
            try
            {
                if (multiTabBrowser1.WindowManager.ActiveBrowser != null)
                    multiTabBrowser1.WindowManager.ActiveBrowser.Navigate(sUrl);
            }
            catch (Exception ee)
            {
                //AllForms.m_frmLog.AppendToLog("NavToUrl\r\n" + ee.ToString());
            }
        }

        public void NavToString(string sUrl)
        {
            if (!CheckWBPointer())
                return;
            try
            {
                if (multiTabBrowser1.WindowManager.ActiveBrowser != null)
                    multiTabBrowser1.WindowManager.ActiveBrowser.DocumentText = sUrl;
            }
            catch (Exception ee)
            {
                //AllForms.m_frmLog.AppendToLog("NavToUrl\r\n" + ee.ToString());
            }
        }

        private bool CheckWBPointer()
        {

            return (multiTabBrowser1.WindowManager.ActiveBrowser == null) ? false : true;
        }





        #region Favorites Handling

        //Use a FileSystemWatcher to determine whether to reload favorites upon
        //dropping down or not.
        //To be more effeicent, I would have, in case of
        //Create, insert a new menu item in the appropriate index
        //delete, remove the menu item
        //renamed, modify the text
        //changed, modify text and/or url
        private bool m_FavNeedReload = false;

        //private void LoadFavoriteMenuItems()
        //{
        //    try
        //    {
        //        this.Cursor = Cursors.WaitCursor;
        //        DirectoryInfo objDir = new DirectoryInfo(fswFavorites.Path);
        //        //Recurse, starting from main dir
        //        LoadFavoriteMenuItems(objDir, tsFavoritesMnu);
        //        this.Cursor = Cursors.Default;
        //    }
        //    catch (Exception ee)
        //    {
        //        this.Cursor = Cursors.Default;
        //        //WinGUIMain.AllForms.m_frmLog.AppendToLog("LoadFavoriteMenuItems\r\n" + ee.ToString());
        //    }
        //}

        /// <summary>
        /// Recursive function
        /// </summary>
        /// <param name="objDir"></param>
        //private void LoadFavoriteMenuItems(DirectoryInfo objDir, ToolStripMenuItem menuitem)
        //{
        //    try
        //    {
        //        string strName = string.Empty;
        //        string strUrl = string.Empty;

        //        DirectoryInfo[] dirs = objDir.GetDirectories();
        //        foreach (DirectoryInfo dir in dirs)
        //        {

        //            ToolStripMenuItem diritem = new ToolStripMenuItem(dir.Name, tsFileMnuOpen.Image);
        //            menuitem.DropDownItems.Add((ToolStripItem)diritem);
        //            LoadFavoriteMenuItems(dir, diritem);
        //        }

        //        bool addlinks = (objDir.Name.Equals("links", 
        //            StringComparison.CurrentCultureIgnoreCase)) ? true : false;
        //        FileInfo[] urls = objDir.GetFiles("*.url");
        //        foreach (FileInfo url in urls)
        //        {
        //            strName = Path.GetFileNameWithoutExtension(url.Name);
        //            strUrl = m_CurWB.ResolveInternetShortCut(url.FullName);
        //            //load up quick links
        //            if (addlinks)
        //            {
        //                ToolStripButton btn = new ToolStripButton(strName, m_imgUnLock);
        //                btn.Tag = strUrl;
        //                btn.Click += new EventHandler(ToolStripLinksButtonClickHandler);
        //                tsLinks.Items.Add((ToolStripItem)btn);
        //            }
        //            ToolStripMenuItem item = new ToolStripMenuItem(strName, m_imgUnLock);
        //            item.Tag = strUrl;
        //            item.Click += new EventHandler(ToolStripFavoritesMenuClickHandler);
        //            menuitem.DropDownItems.Add((ToolStripItem)item);
        //        }
        //    }
        //    catch (Exception ee)
        //    {
        //        //WinGUIMain.AllForms.m_frmLog.AppendToLog("LoadFavoriteMenuItems\r\n" + ee.ToString());
        //    }
        //}



        #endregion

        #region TextSize

        /// <summary>
        /// Sets browser text size based on given parameter 0-4
        /// Adjust the chack state of textsize menu items
        /// </summary>
        /// <param name="iLevel">Text size level 0-4</param>
        private void SetZoomLevel(int iLevel)
        {

            //tsViewMnuTextSizeLargest.Checked = false;
            //tsViewMnuTextSizeLarger.Checked = false;
            //tsViewMnuTextSizeMedium.Checked = false;
            //tsViewMnuTextSizeSmaller.Checked = false;
            //tsViewMnuTextSizeSmallest.Checked = false;

            //switch (iLevel)
            //{
            //    case 0:
            //        tsViewMnuTextSizeLargest.Checked = true;
            //        if (DomainGenieApplication.CurrentBrowser != null)
            //            DomainGenieApplication.CurrentBrowser.TextSize = (IfacesEnumsStructsClasses.TextSizeWB)TextSizeWB.Largest;
            //        break;
            //    case 1:
            //        tsViewMnuTextSizeLarger.Checked = true;
            //        if (DomainGenieApplication.CurrentBrowser != null)
            //            DomainGenieApplication.CurrentBrowser.TextSize = (IfacesEnumsStructsClasses.TextSizeWB)TextSizeWB.Larger;
            //        break;
            //    case 2:
            //        tsViewMnuTextSizeMedium.Checked = true;
            //        if (DomainGenieApplication.CurrentBrowser != null)
            //            DomainGenieApplication.CurrentBrowser.TextSize = (IfacesEnumsStructsClasses.TextSizeWB)TextSizeWB.Medium;
            //        break;
            //    case 3:
            //        tsViewMnuTextSizeSmaller.Checked = true;
            //        if (DomainGenieApplication.CurrentBrowser != null)
            //            DomainGenieApplication.CurrentBrowser.TextSize = (IfacesEnumsStructsClasses.TextSizeWB)TextSizeWB.Smaller;
            //        break;
            //    case 4:
            //        tsViewMnuTextSizeSmallest.Checked = true;
            //        if (DomainGenieApplication.CurrentBrowser != null)
            //            DomainGenieApplication.CurrentBrowser.TextSize = (IfacesEnumsStructsClasses.TextSizeWB)TextSizeWB.Smallest;
            //        break;
            //}
        }

        /// <summary>
        /// Hanldes textsize menu item clicks
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tsMnuTextSizeClickHandler(object sender, EventArgs e)
        {
            //if (sender == tsViewMnuTextSizeLargest)
            //    SetZoomLevel(0);
            //else if (sender == tsViewMnuTextSizeLarger)
            //    SetZoomLevel(1);
            //else if (sender == tsViewMnuTextSizeMedium)
            //    SetZoomLevel(2);
            //else if (sender == tsViewMnuTextSizeSmaller)
            //    SetZoomLevel(3);
            //else if (sender == tsViewMnuTextSizeSmallest)
            //    SetZoomLevel(4);
        }

        /// <summary>
        /// Updates the check state of the text size menu items before displaying them
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tsMnuTextSize_DropDownOpening(object sender, EventArgs e)
        {

        }

        #endregion



        //private void tabControl2_GetTabRegion(object sender, MdiTabControl.TabControl.GetTabRegionEventArgs e)
        //{

        //}

        #region --- TABCONTROL #1 -------------------------------------------

        private void LoadDefaultTabs()
        {
            int i1 = IsFormLoaded("WhoisForm", tabControl1);
            if (i1 < 0)
            {
                WhoisForm f = new WhoisForm();
                f.Name = "WhoisForm";
                f.Text = "Domain Generator & Checker";
                //f.Owner = this;   
                MdiTabControl.TabPage x = tabControl1.TabPages.Add(f);
                x.CloseButtonVisible = false;
                x.MouseClick += new MouseEventHandler(tabControl1_MouseClick);
                x.BackLowColorDisabled = Color.FromArgb(190, 201, 202);
                x.BackLowColor = Color.FromArgb(69, 69, 69);
                f.BackColor = x.BackLowColor;
                
            }
            //((MainBlotterForm)(tabControl1.SelectedForm)).MenuMerge(mainToolStrip, mainMenuStrip);

            //int i2 = IsFormLoaded("NameGeneratorForm", tabControl1);
            //if (i2 < 0)
            //{
            //    NameGeneratorForm f = new NameGeneratorForm();
            //    f.Name = "NameGeneratorForm";
            //    f.Text = "Name Generator";
            //    //f.Owner = this;   
            //    MdiTabControl.TabPage x = tabControl1.TabPages.Add(f);
            //    x.CloseButtonVisible = false;
            //    x.MouseClick += new MouseEventHandler(tabControl1_MouseClick);
            //    x.BackLowColorDisabled = Color.FromArgb(190, 201, 202);
            //    x.BackLowColor = Color.FromArgb(190, 201, 202);
            //    f.BackColor = x.BackLowColor;
            //}

            int i3 = IsFormLoaded("DictionaryForm", tabControl1);
            if (i3 < 0)
            {
                DictionaryForm f = new DictionaryForm();
                f.Name = "DictionaryForm";
                f.Text = "Language Dictionaries";
                //f.Owner = this;   
                MdiTabControl.TabPage x = tabControl1.TabPages.Add(f);
                x.CloseButtonVisible = false;
                x.MouseClick += new MouseEventHandler(tabControl1_MouseClick);
                x.BackLowColorDisabled = Color.FromArgb(190, 201, 202);
                x.BackLowColor = Color.FromArgb(69, 69, 69);
                f.BackColor = x.BackLowColor;
            }

            //Load webBrowser First
            //int ii = IsFormLoaded("WebForm", tabControl2);
            //if (ii < 0)
            //{
            //    Form f = new WebForm();
            //    f.Name = "WebForm";
            //    f.Text = "WebForm";
            //    MdiTabControl.TabPage x = tabControl2.TabPages.Add(f);
            //    //x.MouseUp += new MouseEventHandler(this.tabControl1.MouseUp);

            //    x.CloseButtonVisible = false;
            //    x.MouseClick += new MouseEventHandler(tabControl2_MouseClick);
            //    x.BackLowColorDisabled = Color.FromArgb(190, 201, 202);
            //    x.BackLowColor = Color.FromArgb(190, 201, 202);
            //    f.BackColor = x.BackLowColor;

            //    //string url = DomainGenieApplication.GetManualPath();
            //    //url = url + @"\logo.html";
            //    //url = "http://intranet/";

                

            //}
            tabControl1.TabPages[0].Select();
            //tabControl2.TabPages[0].Select();

        }

        private int IsFormLoaded(string formname, MdiTabControl.TabControl tc)
        {
            int iLoaded = -1;
            string words = "";
            string delimStr = ":";
            char[] delimiter = delimStr.ToCharArray();
            string[] split = null;
            string test = "";
            if (tc.TabPages.Count > 0)
            {
                for (int x = 0; x < tc.TabPages.Count; x++)
                {
                    words = tc.TabPages[x].Form.ToString();
                    split = words.Split(delimiter);
                    test = split[1];
                    if (test.Contains(formname))
                        iLoaded = x;
                }
            }
            return iLoaded;
        }


        private void tabControl1_GetTabRegion(object sender, MdiTabControl.TabControl.GetTabRegionEventArgs e)
        {
            e.Points[1] = new Point(e.TabHeight - 2, 2);
            e.Points[2] = new Point(e.TabHeight + 2, 0);
        }
        private void tabControl2_GetTabRegion(object sender, MdiTabControl.TabControl.GetTabRegionEventArgs e)
        {
            e.Points[1] = new Point(e.TabHeight - 2, 2);
            e.Points[2] = new Point(e.TabHeight + 2, 0);
        }

        private void tabControl1_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Right)
            {
                if (tabControl1 == null)
                    return;

                //ContextMenuStrip x = new ContextMenuStrip();
                //Image i1 = global::DomainGenie.Properties.Resources.tearoff16x16;
                //Image i2 = global::TradingBlotter.Properties.Resources.CloseHot;
                //ToolStripItem t = x.Items.Add("Tear Off", i1, new EventHandler(TearOff));
                //t = x.Items.Add("Close Tab", i2, new EventHandler(CloseTab));
                //t.Tag = sender;
                //x.Show((Control)sender, e.Location);
            }
        }
        //private void tabControl2_MouseClick(object sender, MouseEventArgs e)
        //{
        //    if (e.Button == System.Windows.Forms.MouseButtons.Right)
        //    {
        //        if (tabControl2 == null)
        //            return;

        //        //ContextMenuStrip x = new ContextMenuStrip();
        //        //Image i1 = global::DomainGenie.Properties.Resources.tearoff16x16;
        //        //Image i2 = global::TradingBlotter.Properties.Resources.CloseHot;
        //        //ToolStripItem t = x.Items.Add("Tear Off", i1, new EventHandler(TearOff));
        //        //t = x.Items.Add("Close Tab", i2, new EventHandler(CloseTab));
        //        //t.Tag = sender;
        //        //x.Show((Control)sender, e.Location);
        //    }
        //}

        private void tabControl1_TabIndexChanged(object sender, EventArgs e)
        {
            //MessageBox.Show(tabControl1.TabPages.Count.ToString());
        }


        void TearOff(object sender, EventArgs e)
        {
            if (tabControl1 == null)
                return;
            //sender.tag.Form.close();
            //ToolStripItem ts = (ToolStripItem)sender;
            //Form aa = (Form)tabControl1.TabPages[tabControl1.TabPages.SelectedIndex()].Form;

            ToolStripManager.RevertMerge("menuStrip1");
            ToolStripManager.RevertMerge("toolStrip1");
            Form f = tabControl1.TabPages.TearOff(tabControl1.TabPages.SelectedTab());


            //f.MenuRevertMerge();
            //f.Owner = this; //important partial child behavior
            //f.Name = "Form1";
            //f.Text = "Form1";
            //MdiTabControl.TabPage x = tabControl1.TabPages.Add(f);
            //x.MouseClick += new MouseEventHandler(tabControl1_MouseClick);

            //Type t = aa.GetType();
            //Form f = (Form)Activator.CreateInstance(t); 
            //f.Show();
        }


        public void SetTabTop(Form tabform, EventArgs e)
        {
            MdiTabControl.TabPage x = tabControl1.TabPages.Add(tabform);
            x.MouseClick += new MouseEventHandler(tabControl1_MouseClick);
        }


        public void SetTabBottom(Form tabform, EventArgs e)
        {
            //MdiTabControl.TabPage x = tabControl2.TabPages.Add(tabform);
            //x.MouseClick += new MouseEventHandler(tabControl2_MouseClick);
        }

        private void tabControl1_SelectedTabChanged(object sender, EventArgs e)
        {
            if (tabControl1 == null)
                return;

            // Bill SerGio: First removes merged menues from WinGUIMain
            ToolStripManager.RevertMerge("menuStrip1");
            ToolStripManager.RevertMerge("toolStrip1");

            Form aa = (Form)tabControl1.TabPages[tabControl1.TabPages.SelectedIndex()].Form;
            string zform = aa.Name.ToString();

        }
        private void tabControl2_SelectedTabChanged(object sender, EventArgs e)
        {
            //if (tabControl2 == null)
            //    return;

            //// Bill SerGio: First removes merged menues from WinGUIMain
            //ToolStripManager.RevertMerge("menuStrip1");
            //ToolStripManager.RevertMerge("toolStrip1");

            //Form aa = (Form)tabControl2.TabPages[tabControl2.TabPages.SelectedIndex()].Form;
            //string zform = aa.Name.ToString();

        }

        private void tabControl1_Load(object sender, EventArgs e)
        {

        }

        #endregion --- TABCONTROL #1 ----------------------------------------

        private void WinGUIMain_Shown(object sender, EventArgs e)
        {
            if (multiTabBrowser1.WindowManager.ActiveBrowser != null)
                multiTabBrowser1.WindowManager.ActiveBrowser.Navigate("http://www.Domain-Genie.com/");
        }



        public void AddNewDomainName(string newDomain)
        {
            if (tabControl1 == null)
                return;


            WhoisForm aa = (WhoisForm)tabControl1.TabPages[0].Form;
            aa.AddNewDomainName(newDomain);



        }

        private void WinGUIMain_Resize(object sender, EventArgs e)
        {

        }

        private void tsToolsMnuHandler(object sender, EventArgs e)
        {
            //if (sender == tsToolsMnuLaunchRuler)
            //    LaunchApp("ruler.exe");
            //else if (sender == tsToolsMnuLaunchGetColor)
            //    LaunchApp("getcolor.exe");
            //else if (sender == tsToolsMnuLaunchKiller)
            //    LaunchApp("killer.exe");

        }


        private void LaunchApp(string exeFile)
        {
            ProcessStartInfo myProcessStartInfo;
            Process myProcess;
            String aa = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location);
            String strProgram = Path.Combine(aa, exeFile);
            if (File.Exists(strProgram))
            {
                myProcessStartInfo = new ProcessStartInfo(strProgram);
                myProcessStartInfo.UseShellExecute = false;
                myProcessStartInfo.RedirectStandardOutput = true;
                myProcessStartInfo.RedirectStandardError = true;
                myProcessStartInfo.RedirectStandardInput = true;
                myProcessStartInfo.CreateNoWindow = true;
                myProcessStartInfo.Arguments = null;
                myProcess = new Process();
                myProcess.StartInfo = myProcessStartInfo;

                try
                {
                    myProcess.Start();
                }
                catch (Exception ex)
                {
                }
            }
        }



        //private void tsmAuthorizeSoftware_Click(object sender, EventArgs e)
        //{
        //    ToolStripMenuItem tmi = sender as ToolStripMenuItem;
        //    if (tmi != null && tmi.HasDropDownItems)
        //    {
        //        tmi.HideDropDown();
        //        (tmi.OwnerItem as ToolStripMenuItem).HideDropDown();
        //    }
           
        //    string bSerialNumber = string.Empty;
        //    string bAuthorizationCode = string.Empty;

        //    FormLogin splashLogin = new FormLogin();
        //    try
        //    {
        //        splashLogin.ShowDialog();

        //        if(splashLogin.DialogResult == DialogResult.OK) 
        //        {
        //            //bSerialNumber = splashLogin.sSerialNumber.TrimEnd();
        //            //bAuthorizationCode = splashLogin.sAuthorizationCode.TrimEnd();

        //            if (bAuthorizationCode.Length < 4)
        //            {
        //                splashLogin.Close();
        //                DomainGenieApplication.m_bAuthorized = false;
        //            }
        //            else
        //                DomainGenieApplication.m_bAuthorized = true;

        //        }
        //        else if (splashLogin.DialogResult == DialogResult.Cancel)
        //        {
        //            DomainGenieApplication.m_bAuthorized = false;
        //        }
        //        else
        //        {
        //            splashLogin.Close();
        //            DomainGenieApplication.m_bAuthorized = false;
        //        }

        //    } // End try
        //    catch (Exception ex)
        //    {
        //        //MessageBox.Show(ex.Message);
        //        //splashLogin.Close();
        //        //return 0;
        //    } // End catch

        //    splashLogin.Close();



        //}



        private void tsFileMnuHandler(object sender, EventArgs e)
        {
            ToolStripMenuItem tmi = sender as ToolStripMenuItem;
            if (tmi != null && tmi.HasDropDownItems)
            {
                tmi.HideDropDown();
                (tmi.OwnerItem as ToolStripMenuItem).HideDropDown();
            }
            //if (sender == tsFileMnuSaveDocument)
            //{
            //    //LaunchApp("ruler.exe");
            //}
            //else if (sender == tsFileMnuSaveDocumentImage)
            //{
            //    //LaunchApp("getcolor.exe");
            //}
            //else if (sender == tsFileMnuPrint)
            //{
            //    //LaunchApp("killer.exe");
            //}
            //else if (sender == tsFileMnuPrintPreview)
            //{
            //    //LaunchApp("killer.exe");
            //}
            else if (sender == tsFileMnuExit)
            {
                Application.Exit();
            }
        }

        //WebBrowser.ScriptErrorsSuppressed = true;
        private void tsHelpMnuHandler(object sender, EventArgs e)
        {
            ToolStripMenuItem tmi = sender as ToolStripMenuItem;
            if (tmi != null && tmi.HasDropDownItems)
            {
                tmi.HideDropDown();
                (tmi.OwnerItem as ToolStripMenuItem).HideDropDown();
            }
            if (sender == tsHelpMnuDomainGenie)
            {
                if (multiTabBrowser1.WindowManager.ActiveBrowser != null)
                    multiTabBrowser1.WindowManager.ActiveBrowser.Navigate("http://www.Domain-Genie.com/");
            }
            else if (sender == tsHelpMnuWomen)
            {
                if (multiTabBrowser1.WindowManager.ActiveBrowser != null)
                    multiTabBrowser1.WindowManager.ActiveBrowser.Navigate("http://www.Match-r-us.com/");
            }
            else if (sender == tsHelpMnuBuyTVTime)
            {
                if (multiTabBrowser1.WindowManager.ActiveBrowser != null)
                    multiTabBrowser1.WindowManager.ActiveBrowser.Navigate("http://www.GeminiGroupTV.com/");
            }
            else if (sender == tsHelpMnuSoftware)
            {
                if (multiTabBrowser1.WindowManager.ActiveBrowser != null)
                    multiTabBrowser1.WindowManager.ActiveBrowser.Navigate("http://www.Software-rus.com/");
            }
            else if (sender == tsHelpMnuCloud)
            {
                if (multiTabBrowser1.WindowManager.ActiveBrowser != null)
                    multiTabBrowser1.WindowManager.ActiveBrowser.Navigate("http://www.Cloud-Genie.com/");
            }
            else if (sender == tsHelpMnuMalibuDiet)
            {
                if (multiTabBrowser1.WindowManager.ActiveBrowser != null)
                    multiTabBrowser1.WindowManager.ActiveBrowser.Navigate("http://www.Malibu-Diet.com/");
            }
            else if (sender == tsHelpMnuThetherTV)
            {
                if (multiTabBrowser1.WindowManager.ActiveBrowser != null)
                    multiTabBrowser1.WindowManager.ActiveBrowser.Navigate("http://www.TetherTV.com/");
            }
        }

        private void tsAuthorizeMnuHandler(object sender, EventArgs e)
        {
            ToolStripMenuItem tmi = sender as ToolStripMenuItem;
            if (tmi != null && tmi.HasDropDownItems)
            {
                tmi.HideDropDown();
                (tmi.OwnerItem as ToolStripMenuItem).HideDropDown();
            }
            //if (sender == tsAuthorizeMnuAuthorize)
            //{
            //    //using (BlackBox.FormLogin splashLogin = new BlackBox.FormLogin())
            //    //{
            //    //}
            //    BlackBox.FormLogin loginForm = new BlackBox.FormLogin();
            //    loginForm.ShowDialog();

            //    //AUTHORIZE BUTTON CLICKED
            //    if (loginForm.returnStatus == DialogResult.OK)
            //    {
            //        SoftwareLock SLGen = new SoftwareLock();
            //        SLGen.AppID = "DG1732";
            //        SLGen.RegistryHive = SoftwareLock.RegistryHives.CURRENTUSER;
            //        SLGen.RegistryBaseKey = "Ouslan";
            //        SLGen.RegistrySubKey = "DG1732";
            //        DomainGenieApplication.m_bAuthorized = SLGen.isRegistered;
            //        DomainGenieApplication.m_sOptions = SLGen.CustOptions;
            //    }
            //    //if (loginForm.returnStatus == DialogResult.Cancel)
            //    //{
            //    //    loginForm.Close();
            //    //    Environment.Exit(0);
            //    //    //return 0;
            //    //}
            //    //if (loginForm.returnStatus == DialogResult.Ignore)
            //    //{
            //    //    //appInstance.Init();
            //    //    //appInstance.StartMainGui(initialStartupState);

            //    //    //return 0;	// OK
            //    //}
            //}
            //else if (sender == tsAuthorizeMnuPurchase)
            //{
            //    if (multiTabBrowser1.WindowManager.ActiveBrowser != null)
            //        multiTabBrowser1.WindowManager.ActiveBrowser.Navigate("http://www.Domain-Genie.com#bi");
            //}

        }









        //private void splitContainer1_Panel1_Resize(object sender, EventArgs e)
        //{
        //    if((tabControl1.TabPages.SelectedIndex() > -1) &&
        //        (tabControl1.TabPages[tabControl1.TabPages.SelectedIndex()].Form != null))
        //    {
        //        Form aa = (Form)tabControl1.TabPages[tabControl1.TabPages.SelectedIndex()].Form;
        //        string zform = aa.Name.ToString();
        //        if (zform == "WhoisForm")
        //            MessageBox.Show("Eureka!");
        //    }
        //}




    }//END MAIN CLASS


    /// <summary>
    /// Author: Bill SerGio
    /// Simple class to encapsulate global forms, controls, consts, and methods
    /// </summary>
    public sealed class AllForms
    {
        public const string COOKIE = "Cookie:";
        public const string VISITED = "Visited:";
        public const string DLG_HTMLS_FILTER = "Html files (*.html)|*.html|Htm files (*.htm)|*.htm|Text files (*.txt)|*.txt|All files (*.*)|*.*";
        public const string DLG_XMLS_FILTER = "XML files (*.xml)|*.xml";
        public const string DLG_TEXTFILES_FILTER = "Text files (*.txt)|*.txt|All files (*.*)|*.*";
        public const string DLG_IMAGES_FILTER = "Bmp files (*.bmp)|*.bmp" +
                        "|Gif files (*.gif)|*.gif" +
                        "|Jpeg files (*.Jpeg)|*.Jpeg" +
                        "|Png files (*.png)|*.png" +
                        "|Wmf files (*.wmf)|*.wmf" +
                        "|Tiff files (*.tiff)|*.tiff" +
                        "|Emf files (*.emf)|*.emf";

        //public static frmLog m_frmLog = new frmLog();
        //public static frmDynamicConfirm m_frmDynamicConfirm = new frmDynamicConfirm();
        //public static frmInput m_frmInput = new frmInput();
        public static ImageList m_imgListMain = new ImageList();
        public static SaveFileDialog m_dlgSave = new SaveFileDialog();
        public static OpenFileDialog m_dlgOpen = new OpenFileDialog();

        public static Icon BitmapToIcon(Image orgImage)
        {
            Icon icoRet = null;
            if (orgImage == null)
                return icoRet;
            Bitmap bmp = new Bitmap(orgImage);
            icoRet = Icon.FromHandle(bmp.GetHicon());
            bmp.Dispose();
            return icoRet;
        }


        /// <summary>
        /// Author: Bill SerGio
        /// Using m_imgListMain static member
        /// </summary>
        /// <param name="orgImage"></param>
        /// <returns></returns>
        public static Icon BitmapToIcon(int orgImage)
        {
            Icon icoRet = null;
            if (AllForms.m_imgListMain.Images.Count > 0)
            {
                Bitmap bmp = new Bitmap(AllForms.m_imgListMain.Images[orgImage]);
                icoRet = Icon.FromHandle(bmp.GetHicon());
                bmp.Dispose();
            }
            return icoRet;
        }


        /// <summary>
        /// Author: Bill SerGio
        /// replace = visited: or cookie:
        /// </summary>
        /// <param name="pattern"></param>
        /// <param name="replace"></param>
        /// <returns></returns>
        public static string SetupCookieCachePattern(string pattern, string replace)
        {
            const string COOKIECACHEPATTERN = ".*";
            const string DOT = ".";
            const string BACKSLASHDOT = "\\.";

            string url = pattern;
            if (url.Length > 0)
            {
                Uri curUri = new Uri(url);
                url = curUri.Host;
                //Replace "." with "\\."
                url = url.Replace(DOT, BACKSLASHDOT);
                url = replace + COOKIECACHEPATTERN + url;

                //www.google.com
                //visited:.*www\\.google\\.com

                //login.live.com
                //cookie:.*login\\.live\\.com

            }
            return url;
        }

        /// <summary>
        /// A little shortcut when asking for yes or no type of confirmation
        /// </summary>
        /// <param name="Msg"></param>
        /// <param name="Win"></param>
        /// <returns></returns>
        public static bool AskForConfirmation(string Msg, IWin32Window Win)
        {
            const string CONFIRMATIONREQUESTED = "Confirmation Requested";
            DialogResult result = MessageBox.Show(Win, Msg, CONFIRMATIONREQUESTED, MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            return (result == DialogResult.Yes) ? true : false;
        }


        public static DialogResult ShowStaticSaveDialog(IWin32Window Win,
            string defaultext, string filename,
            string filter, string title, string initialdir)
        {
            if (string.IsNullOrEmpty(defaultext))
                AllForms.m_dlgSave.DefaultExt = "txt";
            else
                AllForms.m_dlgSave.DefaultExt = defaultext;

            if (string.IsNullOrEmpty(filename))
                AllForms.m_dlgSave.FileName = "FileName";
            else
                AllForms.m_dlgSave.FileName = filename;

            if (string.IsNullOrEmpty(filter))
                AllForms.m_dlgSave.Filter = DLG_TEXTFILES_FILTER;
            else
                AllForms.m_dlgSave.Filter = filter;

            if (string.IsNullOrEmpty(title))
                AllForms.m_dlgSave.Title = "Save File";
            else
                AllForms.m_dlgSave.Title = title;

            if (string.IsNullOrEmpty(initialdir))
                AllForms.m_dlgSave.InitialDirectory = Environment.CurrentDirectory;
            else
                AllForms.m_dlgSave.InitialDirectory = initialdir;

            return AllForms.m_dlgSave.ShowDialog(Win);
        }

        public static DialogResult ShowStaticSaveDialogForText(IWin32Window Win)
        {
            return ShowStaticSaveDialog(Win, string.Empty, string.Empty, string.Empty, string.Empty, string.Empty);
        }

        public static DialogResult ShowStaticSaveDialogForImage(IWin32Window Win)
        {
            return ShowStaticSaveDialog(Win, "bmp", "ImageFileName", DLG_IMAGES_FILTER, "Save Image", string.Empty);
        }

        public static DialogResult ShowStaticSaveDialogForXML(IWin32Window Win)
        {
            return ShowStaticSaveDialog(Win, "xml", "XMLFileName", DLG_XMLS_FILTER, "Save XML", string.Empty);
        }

        public static DialogResult ShowStaticOpenDialog(IWin32Window Win,
            string filter, string title, string initialdir, bool showreadonly)
        {
            AllForms.m_dlgOpen.Filter = filter;

            if (string.IsNullOrEmpty(title))
                AllForms.m_dlgOpen.Title = "Open File";
            else
                AllForms.m_dlgOpen.Title = title;

            if (string.IsNullOrEmpty(initialdir))
                AllForms.m_dlgOpen.InitialDirectory = Environment.CurrentDirectory;
            else
                AllForms.m_dlgOpen.InitialDirectory = initialdir;

            AllForms.m_dlgOpen.ShowReadOnly = showreadonly;

            return AllForms.m_dlgOpen.ShowDialog(Win);
        }


        public static void LoadWebColors(ComboBox combo)
        {
            Array knownColors = Enum.GetValues(typeof(System.Drawing.KnownColor));
            //First add an empty color
            combo.Items.Add(Color.Empty);
            //Then the rest
            foreach (KnownColor k in knownColors)
            {
                Color c = Color.FromKnownColor(k);

                if (!c.IsSystemColor && (c.A > 0))
                {
                    combo.Items.Add(c);
                }
            }
            //Select default
            combo.SelectedIndex = 0;
        }









    }


}



//FileStream stmRecords = new FileStream("Conserve.txt", FileMode.Create, FileAccess.Write, FileShare.None);
//StreamWriter stmWriter = new StreamWriter(stmRecords);

//for (int i = 0; i < this.textBox1.Lines.Length; i++)
//{
//    //stmWriter.WriteLine(this.textBox1.Lines[i].ToString());
//    //this.textBox1.Lines[i].ToString()

//}

//stmWriter.Flush();
//stmWriter.Close();
/*
foreach (FileInfo fiInfo in srcFiles)
{
    freeIndex = WaitHandle.WaitAny(threadEvents, new TimeSpan(0, 2, 0), false);
    if (freeIndex == WaitHandle.WaitTimeout)
    {
        AbortAllWorkerThreads();
        freeIndex = 0;
    }
    Thread.Sleep(1);
    string sourceFile = fiInfo.FullName;
    threadEvents[freeIndex] = new ManualResetEvent(false);
    curFileDetail[freeIndex] = new ThreadClass(sourceFile, threadEvents[freeIndex]);
    processThread[freeIndex] = new Thread(new ParameterizedThreadStart(LoadInputXml));
    processThread[freeIndex].Name = freeIndex.ToString();
    processThread[freeIndex].Start(curFileDetail[freeIndex]);

}
*/



/*
public partial class Main : Form
{
  delegate void SetStatusCallback(String text, int nPercent);

  private void buttonGo_Click(object sender, EventArgs e)
  {
    backgroundWorker1.RunWorkerAsync();
  }

  private void SetStatus(String text, int nPercent)
  {
    if (statusStrip1.InvokeRequired) {
      SetStatusCallback d = new SetStatusCallback(SetStatus);
      this.Invoke(d, new object[] { text, nPercent } );
    } else {
      labelStatus.Text = text;
      progressStatus.Value = nPercent;
    }
  }

  private void backgroundWorker1_DoWork(
    object sender,
    DoWorkEventArgs e)
  {
    SetStatus(”Creating HTTP Request”, 20) ;
    …
    SetStatus(”Using POST method”, 40) ;
    …
  }
}

*/